import java.util.*;
class QuicksortBasic implements QuickSort {
  public ArrayList<Integer> sort(ArrayList<Integer> a) {
    
    if (a.isEmpty()) return new ArrayList<Integer>();
    
    ArrayList<Integer> left = new ArrayList<Integer>();
    ArrayList<Integer> mid = new ArrayList<Integer>();
    ArrayList<Integer> right = new ArrayList<Integer>();
    
    for (Integer i : a)
      if ( i < a.get(0) ) 
        left.add(i); // Use element 0 as pivot
      else if ( i > a.get(0)) 
        right.add(i);
      else 
        mid.add(i);
    
    ArrayList<Integer> left_s = sort(left);
    ArrayList<Integer> right_s = sort(right);
    
    left_s.addAll(mid); 
    left_s.addAll(right_s); 
    
    return left_s;
  }
}